package ri25c3.ctf;

import java.util.regex.Pattern;

public final class Assignment {
	private final Pattern pattern;

	private final String path;

	private final String function;

	public Assignment(final Pattern pattern, final String path,
			final String function) {
		super();
		this.pattern = pattern;
		this.path = path;
		this.function = function;
	}

	public String getFunction() {
		return function;
	}

	public String getPath() {
		return path;
	}

	public Pattern getPattern() {
		return pattern;
	}

	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result
				+ ((function == null) ? 0 : function.hashCode());
		result = PRIME * result + ((path == null) ? 0 : path.hashCode());
		result = PRIME * result + ((pattern == null) ? 0 : pattern.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final Assignment other = (Assignment) obj;
		if (function == null) {
			if (other.function != null)
				return false;
		} else if (!function.equals(other.function))
			return false;
		if (path == null) {
			if (other.path != null)
				return false;
		} else if (!path.equals(other.path))
			return false;
		if (pattern == null) {
			if (other.pattern != null)
				return false;
		} else if (!pattern.equals(other.pattern))
			return false;
		return true;
	}

}
