package ri25c3.ctf;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.Socket;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Client implements Runnable {
	private final Socket s;

	private BufferedReader br;

	private PrintStream ps;

	public Client(Socket s) throws IOException {
		this.s = s;
		br = new BufferedReader(new InputStreamReader(s.getInputStream()));
		ps = new PrintStream(s.getOutputStream());
	}

	private void invalid() {
		ps
				.println("HTTP/1.0 501 Not Implemented\n\n<html><body><p>Error</p></body></html>");
	}

	public void run() {
		try {
			String oneline = br.readLine();
			char[] olc = oneline.toCharArray();
			boolean foobar = false;
			for (int i = 0; i < olc.length; i++) {
				char c = olc[i];
				switch (c) {
				case '"':
					foobar = !foobar;
					break;
				case ' ':
					if (foobar) {
						olc[i] = '\n';
					}
				}
			}
			String[] request = new String(olc).split(" ");
			for (int i = 0; i < request.length; i++) {
				request[i] = request[i].replace("\n", " ");
			}
			Map<String, List<String>> parms = new HashMap<String, List<String>>();
			while (true) {
				String inp = br.readLine();
				if (inp.trim().length() == 0) {
					break;
				}
				String[] line = inp.split(": ", 2);
				if (line.length != 2) {
					invalid();
					return;
				}
				String key = line[0].toLowerCase();
				List<String> values = parms.get(key);
				if (values == null) {
					values = new ArrayList<String>();
					parms.put(key, values);
				}
				values.add(line[1]);
			}
			Requests r = Requests.valueOf(request[0].toUpperCase());
			r.handle(br, ps, request, parms);
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (s != null) {
					s.close();
				}
			} catch (IOException e) {
			}
		}
	}
}
