package ri25c3.ctf;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

public class DB {
	private static DB instance = new DB();

	static {
		try {
			Class.forName("org.hsqldb.jdbcDriver").newInstance();
		} catch (InstantiationException e) {
		} catch (IllegalAccessException e) {
		} catch (ClassNotFoundException e) {
		}
	}

	public static DB getInstance() {
		return instance;
	}

	public Connection getDB(String user) {
		try {
			return DriverManager.getConnection(String.format(
					"jdbc:hsqldb:file:%s%s", user == null ? "" : "USER_",
					user == null ? "main" : user), "sa", "");
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}

	public void initMainDB() throws SQLException {
		Connection c = getDB(null);
		Statement s = c.createStatement();
		try {
			s.execute("CREATE CACHED TABLE users (uid "
					+ "INTEGER IDENTITY, name VARCHAR(256), password "
					+ "VARCHAR(256), fullname VARCHAR(256))");
		} catch (SQLException e) {
		}
		s.execute("SHUTDOWN");
		c.close();
	}
}
