package ri25c3.ctf;

import java.io.BufferedReader;
import java.io.PrintStream;
import java.util.List;
import java.util.Map;

import ri25c3.ctf.handlers.Create;
import ri25c3.ctf.handlers.DTP;
import ri25c3.ctf.handlers.Get;
import ri25c3.ctf.handlers.Post;
import ri25c3.ctf.handlers.Session;

public enum Requests {
	GET(new Get()), POST(new Post()), CREATE(new Create()), DTP(new DTP()), SESSION(
			new Session());

	private final RequestHandler rh;

	private Requests(RequestHandler rh) {
		this.rh = rh;
	}

	public boolean handle(BufferedReader in, PrintStream out, String[] request,
			Map<String, List<String>> parms) {
		return this.rh.handle(in, out, request, parms);
	}
}
