package ri25c3.ctf;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.sql.SQLException;

public class Server implements Runnable {
	private static final int MAX_CONNECTIONS = 40;

	Thread[] handlers = new Thread[MAX_CONNECTIONS];

	public void run() {
		DB db = DB.getInstance();
		try {
			db.initMainDB();
		} catch (SQLException e1) {
			e1.printStackTrace();
			return;
		}
		ServerSocket ss;
		try {
			ss = new ServerSocket(8080);
		} catch (IOException e) {
			e.printStackTrace();
			return;
		}
		while (true) {
			try {
				Socket s = ss.accept();
				Client c = new Client(s);
				if (!getThread(c)) {
					s.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
				continue;
			}
		}
	}

	private boolean getThread(Runnable r) {
		for (int i = 0; i < handlers.length; i++) {
			if ((handlers[i] == null) || (!handlers[i].isAlive())) {
				Thread t = new Thread(r);
				t.setDaemon(true);
				handlers[i] = t;
				t.start();
				return true;
			}
		}
		return false;
	}

	public static void main(String[] args) {
		new Server().run();
	}
}
