package ri25c3.ctf.handlers;

import java.io.BufferedReader;
import java.io.File;
import java.io.PrintStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.List;
import java.util.Map;

import ri25c3.ctf.DB;
import ri25c3.ctf.RequestHandler;

public class Create implements RequestHandler {

	public boolean handle(BufferedReader in, PrintStream out, String[] request,
			Map<String, List<String>> parms) {
		String userName = request[1];
		if (userName.split("[A-Za-z][A-Za-z0-9]+").length != 0) {
			out.println("400 ERROR");
			return false;
		}
		if (request[3].length() < 8) {
			out.println("400 TOO SHORT A PASSWORD, BUD");
			return false;
		}
		try {
			DB db = DB.getInstance();
			Connection c = db.getDB(null);
			PreparedStatement ps = c
					.prepareStatement("select uid from users where name=?");
			ps.setString(1, userName);
			ResultSet rs = ps.executeQuery();
			if (rs.next()) {
				out.println("300 USER EXISTS");
				return false;
			}
			new File("userdata/" + userName).mkdirs();
			ps = c
					.prepareStatement("insert into users (name,password,fullname) values (?,?,?)");
			ps.setString(1, userName);
			ps.setString(2, request[3]);
			ps.setString(3, request[2]);
			ps.execute();
			out.println("200 USER CREATED");
			return true;
		} catch (Throwable t) {
			t.printStackTrace();
			out.println("400 USER COULD NOT BE CREATED");
			return false;
		}
	}

}
