package ri25c3.ctf.handlers;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;
import java.util.Map;

import ri25c3.ctf.DB;
import ri25c3.ctf.RequestHandler;
import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

public class DTP implements RequestHandler {
	private String logIn(String user, String password) {
		Connection c = DB.getInstance().getDB(null);
		try {
			PreparedStatement ps = c
					.prepareStatement("select fullname,password from users where name=?");
			try {
				ps.setString(1, user);
				ResultSet rs = ps.executeQuery();
				if (!rs.next()) {
					return null;
				}
				if (!password.equals(rs.getString(2))) {
					return null;
				}
				return rs.getString(1);
			} finally {
				ps.close();
			}
		} catch (SQLException e) {
		} finally {
			try {
				c.close();
			} catch (SQLException e) {
			}
		}
		return null;
	}

	public boolean handle(BufferedReader in, PrintStream out, String[] request,
			Map<String, List<String>> parms) {
		if (request.length < 5) {
			out.println("100 INVALID PARAMETER COUNT");
			return false;
		}
		if (request[2].split("[A-Za-z][A-Za-z0-9]+").length != 0) {
			out.println("100 Erm, dude. That ain't no username!");
			return false;
		}
		String user = logIn(request[2], request[3]);
		if (user == null) {
			out.println("120 LOGIN INCORRECT");
			return false;
		}
		if ("UPLOAD".equals(request[1])) {
			List<String> lines = parms.get("lines");
			if ((lines == null) || (lines.size() < 1)) {
				out.println("500 LINES NOT SPECIFIED");
				return false;
			}
			int dlines;
			try {
				dlines = Integer.valueOf(lines.get(0));
			} catch (Throwable t) {
				out.println("400 ERROR");
				return false;
			}
			out.println("200 GO AHEAD");
			int i = 0;
			StringBuilder sb = new StringBuilder(72 * dlines);
			while (true) {
				String line;
				try {
					line = in.readLine();
				} catch (IOException e) {
					break;
				}
				if (line.trim().length() == 0) {
					break;
				}
				sb.append(line);
				if (i++ > dlines) {
					out.println("400 ERROR");
					return false;
				}
			}
			try {
				byte[] data = new BASE64Decoder().decodeBuffer(sb.toString());
				try {
					File fofile = new File(String.format("userdata/%s/%s",
							request[2], request[4]));
					if (request[4].endsWith(".cgi")) {
						fofile.createNewFile();
						fofile.setExecutable(true);
					}
					FileOutputStream fos = new FileOutputStream(fofile);
					fos.write(data);
					fos.close();
				} catch (IOException e) {
					out.println("400 FOO GENERIC ERROR");
					return false;
				}
			} catch (IOException e) {
				out.println("300 ENCODING ERROR");
				return false;
			}
			out.println(String.format(
					"200 Thank you, %s, for uploading the file", user));
			return true;
		} else if ("DOWNLOAD".equals(request[1])) {
			File f = new File(String.format("userdata/%s/%s", request[2],
					request[4]));
			try {
				FileInputStream fis = new FileInputStream(f);
				byte[] buf = new byte[(int) f.length()];
				fis.read(buf);
				String foo = new BASE64Encoder().encode(buf);
				int lines = foo.split("\n").length;
				out
						.printf(
								"200 Thank you, %s, your file is %d line%s long in encoded form.\n",
								user, lines, (lines == 1) ? "" : "s");
				out.println(foo);
				return true;
			} catch (FileNotFoundException e) {
				out.println("700 INVALID PATH");
				return false;
			} catch (IOException e) {
				out.println("500 HARD DRIVE FAULTY"); // no, not really ;)
				return false;
			}
		} else if ("MKDIRS".equals(request[1])) {
			File fofile = new File(String.format("userdata/%s/%s", request[2],
					request[4]));
			if (fofile.mkdirs()) {
				out.println("200 MKDIR");
				return true;
			} else {
				out.println("300 !MKDIR");
				return false;
			}
		}
		out.println("100 INVALID COMMAND");
		return false;
	}
}
