package ri25c3.ctf.handlers;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import ri25c3.ctf.DB;

public class HTTPDatabase {
	private Connection c;

	public HTTPDatabase(String user) {
		c = DB.getInstance().getDB(user);
	}

	public boolean execute(String query) {
		try {
			Statement s = c.createStatement();
			try {
				s.execute(query);
				return true;
			} finally {
				s.close();
			}
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
	}

	public List<Object[]> query(String query) {
		try {
			Statement s = c.createStatement();
			try {
				ArrayList<Object[]> foo = new ArrayList<Object[]>();
				int len = query.split(",").length;
				ResultSet r = s.executeQuery(query);
				try {
					while (r.next()) {
						Object[] objs = new Object[len];
						for (int i = 0; i < len; i++) {
							objs[i] = r.getObject(i + 1);
						}
						foo.add(objs);
					}
				} finally {
					r.close();
				}
				return foo;
			} finally {
				s.close();
			}
		} catch (SQLException e) {
			return null;
		}
	}
}
