package ri25c3.ctf.handlers;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

public final class HTTPRequest {
	private final Map<String, List<String>> parms;

	private final String[] request;

	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((parms == null) ? 0 : parms.hashCode());
		result = PRIME * result + Arrays.hashCode(request);
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final HTTPRequest other = (HTTPRequest) obj;
		if (parms == null) {
			if (other.parms != null)
				return false;
		} else if (!parms.equals(other.parms))
			return false;
		if (!Arrays.equals(request, other.request))
			return false;
		return true;
	}

	public Map<String, List<String>> getparms() {
		return parms;
	}

	public String[] getrequest() {
		return request;
	}

	public HTTPRequest(Map<String, List<String>> parms, String[] request) {
		this.parms = parms;
		this.request = request;
	}
}
